Index: trunk/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcrst.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/trcrst.F90	(revision 1119)
@@ -33,11 +33,4 @@
    INTEGER, PUBLIC ::   numrtr, numrtw   !: logical unit for trc restart (read and write)
 
-#if defined key_pisces
-   REAL(wp) ::  &
-     alkmean = 2426. ,  & ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
-     po4mean = 2.165 ,  & ! mean value of phosphates
-     no3mean = 30.90 ,  & ! mean value of nitrate
-     siomean = 91.51      ! mean value of silicate
-#endif
 
    !! * Substitutions
@@ -98,9 +91,4 @@
       INTEGER  ::   iarak0
       REAL(wp) ::   zkt, zarak0
-# if defined key_pisces 
-      REAL(wp) ::   ztrasum
-      INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   caralk, bicarb, co3
-# endif
       !!----------------------------------------------------------------------
 
@@ -172,4 +160,5 @@
       CALL iom_get( numrtr, jpdom_autoglo, 'Silicalim', xksi(:,:) ) 
       CALL iom_get( numrtr, jpdom_autoglo, 'Silicamax', xksimax(:,:) )
+      CALL trc_rst_ini  ! Initialisation of some variables
 #endif
 
@@ -181,115 +170,4 @@
 #endif
 
-#if defined key_pisces 
-         !                                                         ! --------------------------- !
-         IF( cp_cfg == "orca" .AND. .NOT. lk_trc_c1d ) THEN      ! ORCA condiguration (not 1D) !
-            !                                                      ! --------------------------- !
-            ! set total alkalinity, phosphate, NO3 & silicate
-            ! total alkalinity
-            ! -----------------------------------------------
-            ztrasum = 0.e0             
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztrasum = ztrasum + trn(ji,jj,jk,jptal) * tmask(ji,jj,jk) * tmask_i(ji,jj)  &
-#  if defined key_off_degrad
-                        &              * facvol(ji,jj,jk)   &
-#  endif
-                        &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-            IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
-
-
-            ztrasum = ztrasum / areatot * 1.e6
-            IF(lwp) WRITE(numout,*) 'TALK moyen ', ztrasum
-            trn(:,:,:,jptal) = trn(:,:,:,jptal) * alkmean / ztrasum
-            
-            ! phosphate
-            ! ---------
-            ztrasum = 0.e0
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztrasum = ztrasum + trn(ji,jj,jk,jppo4) * tmask(ji,jj,jk) * tmask_i(ji,jj)  &
-#  if defined key_off_degrad
-                     &              * facvol(ji,jj,jk)   &
-#  endif
-                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-            IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
-            
-            ztrasum = ztrasum / areatot * 1.e6 / 122.
-            IF(lwp) WRITE(numout,*) 'PO4 moyen ', ztrasum 
-            trn(:,:,:,jppo4) = trn(:,:,:,jppo4) * po4mean / ztrasum
-            
-            ! NO3
-            ! ---
-            ztrasum = 0.e0
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztrasum = ztrasum + trn(ji,jj,jk,jpno3) * tmask(ji,jj,jk) * tmask_i(ji,jj)  &
-#  if defined key_off_degrad
-                     &              * facvol(ji,jj,jk)   &
-#  endif
-                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-            IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
-            
-            ztrasum = ztrasum / areatot * 1.e6 / 7.6
-            IF(lwp) WRITE(numout,*) 'NO3 moyen ', ztrasum 
-            trn(:,:,:,jpno3) = trn(:,:,:,jpno3) * no3mean / ztrasum
-
-            ! Silicate
-            ! --------
-            ztrasum = 0.e0
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztrasum = ztrasum + trn(ji,jj,jk,jpsil) * tmask(ji,jj,jk) * tmask_i(ji,jj)   &
-#  if defined key_off_degrad
-                     &              * facvol(ji,jj,jk)   &
-#  endif
-                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-            IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
-            
-            IF(lwp) WRITE(numout,*) 'SiO3 moyen ', ztrasum / areatot * 1.e6
-            ztrasum = ztrasum / areatot * 1.e6
-            trn(:,:,:,jpsil) = MIN( 400.e-6,trn(:,:,:,jpsil) * siomean / ztrasum ) 
-            !
-         ENDIF
-
-!#if defined key_kriest
-!      !! Initialize number of particles from a standart restart file
-!      !! The name of big organic particles jpgoc has been only change
-!      !! and replace by jpnum but the values here are concentration
-!      trn(:,:,:,jppoc) = trn(:,:,:,jppoc) + trn(:,:,:,jpnum)
-!      trn(:,:,:,jpnum) = trn(:,:,:,jppoc) / ( 6. * xkr_massp )
-!#endif
-         !!  Set hi (???) from  total alcalinity, borat (???), akb3 (???) and ak23 (???)
-         !!  ---------------------------------------------------------------------
-         DO jk = 1, jpk
-            DO jj = 1, jpj
-               DO ji = 1,jpi
-                  caralk = trn(ji,jj,jk,jptal) - borat(ji,jj,jk) / ( 1. + 1.e-8 / ( rtrn + akb3(ji,jj,jk) ) )
-                  co3    = ( caralk - trn(ji,jj,jk,jpdic) ) *       tmask(ji,jj,jk)   &
-                     &   +             0.5e-3               * ( 1.- tmask(ji,jj,jk) )
-                  bicarb = 2.* trn(ji,jj,jk,jpdic) - caralk
-                  hi(ji,jj,jk) = ( ak23(ji,jj,jk) * bicarb / co3 )   *       tmask(ji,jj,jk)   &
-                     &         +             1.0e-9                  * ( 1.- tmask(ji,jj,jk) )
-               END DO
-            END DO
-         END DO
-#endif
-
       CALL iom_close( numrtr )
       !
@@ -306,6 +184,4 @@
       !!
       INTEGER  :: ji, jj, jk, jn
-      REAL(wp) :: zdiag_var, zdiag_varmin, zdiag_varmax, zdiag_tot
-      REAL(wp) :: zder
       !!----------------------------------------------------------------------
 
@@ -352,40 +228,5 @@
 
        IF( kt == nitrst ) THEN
-          IF(lwp) WRITE(numout,*) '----TRACER STAT----'
-
-          zdiag_tot = 0.e0
-          DO jn = 1, jptra
-             zdiag_var    = 0.e0
-             zdiag_varmin = 0.e0
-             zdiag_varmax = 0.e0
-             DO ji = 1, jpi
-                DO jj = 1, jpj
-                   DO jk = 1,jpk
-                      zdiag_var = zdiag_var + trn(ji,jj,jk,jn) * tmask(ji,jj,jk) * tmask_i(ji,jj)   &
-#if defined key_off_degrad
-                         &   * facvol(ji,jj,jk)   &
-#endif
-                         &   * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-                   END DO
-                END DO
-             END DO
-             
-             zdiag_varmin = MINVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
-             zdiag_varmax = MAXVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
-             IF( lk_mpp ) THEN
-                CALL mpp_min( zdiag_varmin )      ! min over the global domain
-                CALL mpp_max( zdiag_varmax )      ! max over the global domain
-                CALL mpp_sum( zdiag_var    )      ! sum over the global domain
-             END IF
-             zdiag_tot = zdiag_tot + zdiag_var
-             zdiag_var = zdiag_var / areatot
-             IF(lwp) WRITE(numout,*) '   MEAN NO ', jn, ctrcnm(jn), ' = ', zdiag_var,   &
-                &                    ' MIN = ', zdiag_varmin, ' MAX = ', zdiag_varmax
-          END DO
-          
-          zder = ( ( zdiag_tot - trai ) / ( trai + 1.e-12 )  ) * 100._wp
-          IF(lwp) WRITE(numout,*) '   Integral of all tracers over the full domain  = ', zdiag_tot
-          IF(lwp) WRITE(numout,*) '   Drift of the sum of all tracers =', zder, ' %'
-          
+          CALL trc_rst_stat            ! statistics
           CALL iom_close( numrtw )     ! close the restart file (only at last time step)
           lrst_trc = .FALSE.
@@ -393,4 +234,187 @@
       !
    END SUBROUTINE trc_rst_wri
+
+# if defined key_pisces 
+
+   SUBROUTINE trc_rst_ini 
+      !!----------------------------------------------------------------------
+      !!                    ***  trc_rst_ini  ***
+      !!
+      !! ** purpose  : Initialisation of some variables ( hi
+      !!----------------------------------------------------------------------
+      INTEGER  :: ji, jj, jk, jn  
+      REAL(wp) ::  &
+         alkmean = 2426. ,  & ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
+         po4mean = 2.165 ,  & ! mean value of phosphates
+         no3mean = 30.90 ,  & ! mean value of nitrate
+         siomean = 91.51      ! mean value of silicate
+      
+      REAL(wp) ::   ztrasum
+      REAL(wp) ::   caralk, bicarb, co3
+
+      IF(lwp)  WRITE(numout,*)
+
+      IF( cp_cfg == "orca" .AND. .NOT. lk_trc_c1d ) THEN      ! ORCA condiguration (not 1D) !
+         !                                                    ! --------------------------- !
+         ! set total alkalinity, phosphate, NO3 & silicate
+
+         ! total alkalinity
+         ztrasum = 0.e0             
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztrasum = ztrasum + trn(ji,jj,jk,jptal) * tmask(ji,jj,jk) * tmask_i(ji,jj)  &
+#  if defined key_off_degrad
+                     &              * facvol(ji,jj,jk)   &
+#  endif
+                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
+         
+         ztrasum = ztrasum / areatot * 1.e6
+         IF(lwp) WRITE(numout,*) '       TALK mean : ', ztrasum
+         trn(:,:,:,jptal) = trn(:,:,:,jptal) * alkmean / ztrasum
+            
+         ! phosphate
+         ztrasum = 0.e0
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztrasum = ztrasum + trn(ji,jj,jk,jppo4) * tmask(ji,jj,jk) * tmask_i(ji,jj)  &
+#  if defined key_off_degrad
+                     &              * facvol(ji,jj,jk)   &
+#  endif
+                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
+         
+         ztrasum = ztrasum / areatot * 1.e6 / 122.
+         IF(lwp) WRITE(numout,*) '       PO4  mean : ', ztrasum
+         trn(:,:,:,jppo4) = trn(:,:,:,jppo4) * po4mean / ztrasum
+        
+         ! Nitrates          
+         ztrasum = 0.e0
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztrasum = ztrasum + trn(ji,jj,jk,jpno3) * tmask(ji,jj,jk) * tmask_i(ji,jj)  &
+#  if defined key_off_degrad
+                     &              * facvol(ji,jj,jk)   &
+#  endif
+                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
+         
+         ztrasum = ztrasum / areatot * 1.e6 / 7.6
+         IF(lwp) WRITE(numout,*) '       NO3  mean : ', ztrasum
+         trn(:,:,:,jpno3) = trn(:,:,:,jpno3) * no3mean / ztrasum
+         
+         ! Silicate
+         ztrasum = 0.e0
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztrasum = ztrasum + trn(ji,jj,jk,jpsil) * tmask(ji,jj,jk) * tmask_i(ji,jj)   &
+#  if defined key_off_degrad
+                     &              * facvol(ji,jj,jk)   &
+#  endif
+                     &              * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         IF( lk_mpp )   CALL mpp_sum( ztrasum )     ! sum over the global domain  
+         ztrasum = ztrasum / areatot * 1.e6
+         IF(lwp) WRITE(numout,*) '       SiO3 mean : ', ztrasum
+         trn(:,:,:,jpsil) = MIN( 400.e-6,trn(:,:,:,jpsil) * siomean / ztrasum ) 
+         !
+      ENDIF
+
+!#if defined key_kriest
+!     !! Initialize number of particles from a standart restart file
+!     !! The name of big organic particles jpgoc has been only change
+!     !! and replace by jpnum but the values here are concentration
+!     trn(:,:,:,jppoc) = trn(:,:,:,jppoc) + trn(:,:,:,jpnum)
+!     trn(:,:,:,jpnum) = trn(:,:,:,jppoc) / ( 6. * xkr_massp )
+!#endif
+      !!  Set hi (???) from  total alcalinity, borat (???), akb3 (???) and ak23 (???)
+      !!  ---------------------------------------------------------------------
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1,jpi
+               caralk = trn(ji,jj,jk,jptal) - borat(ji,jj,jk) / ( 1. + 1.e-8 / ( rtrn + akb3(ji,jj,jk) ) )
+               co3    = ( caralk - trn(ji,jj,jk,jpdic) ) *       tmask(ji,jj,jk)   &
+                  &   +             0.5e-3               * ( 1.- tmask(ji,jj,jk) )
+               bicarb = 2.* trn(ji,jj,jk,jpdic) - caralk
+               hi(ji,jj,jk) = ( ak23(ji,jj,jk) * bicarb / co3 )   *       tmask(ji,jj,jk)   &
+                  &         +             1.0e-9                  * ( 1.- tmask(ji,jj,jk) )
+            END DO
+         END DO
+      END DO
+
+   END SUBROUTINE trc_rst_ini
+
+#endif
+      !!----------------------------------------------------------------------
+
+   SUBROUTINE trc_rst_stat
+      !!----------------------------------------------------------------------
+      !!                    ***  trc_rst_stat  ***
+      !!
+      !! ** purpose  :   Compute tracers statistics
+      !!----------------------------------------------------------------------
+
+      INTEGER  :: ji, jj, jk, jn
+      REAL(wp) :: zdiag_var, zdiag_varmin, zdiag_varmax, zdiag_tot
+      REAL(wp) :: zder
+      !!----------------------------------------------------------------------
+
+
+      IF( lwp ) THEN
+         WRITE(numout,*) 
+         WRITE(numout,*) '           ----TRACER STAT----             '
+         WRITE(numout,*) 
+      ENDIF
+      
+      zdiag_tot = 0.e0
+      DO jn = 1, jptra
+         zdiag_var    = 0.e0
+         zdiag_varmin = 0.e0
+         zdiag_varmax = 0.e0
+         DO ji = 1, jpi
+            DO jj = 1, jpj
+               DO jk = 1,jpk
+                  zdiag_var = zdiag_var + trn(ji,jj,jk,jn) * tmask(ji,jj,jk) * tmask_i(ji,jj)   &
+#if defined key_off_degrad
+                     &   * facvol(ji,jj,jk)   &
+#endif
+                     &   * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         
+         zdiag_varmin = MINVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
+         zdiag_varmax = MAXVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
+         IF( lk_mpp ) THEN
+            CALL mpp_min( zdiag_varmin )      ! min over the global domain
+            CALL mpp_max( zdiag_varmax )      ! max over the global domain
+            CALL mpp_sum( zdiag_var    )      ! sum over the global domain
+         END IF
+         zdiag_tot = zdiag_tot + zdiag_var
+         zdiag_var = zdiag_var / areatot
+         IF(lwp) WRITE(numout,*) '   MEAN NO ', jn, ctrcnm(jn), ' = ', zdiag_var,   &
+            &                    ' MIN = ', zdiag_varmin, ' MAX = ', zdiag_varmax
+      END DO
+      
+      zder = ( ( zdiag_tot - trai ) / ( trai + 1.e-12 )  ) * 100._wp
+      IF(lwp) WRITE(numout,*) '   Integral of all tracers over the full domain  = ', zdiag_tot
+      IF(lwp) WRITE(numout,*) '   Drift of the sum of all tracers =', zder, ' %'
+      
+   END SUBROUTINE trc_rst_stat
 
 #else
